
function PDAM_GetItemData(slotID)
	local itemLink = GetInventoryItemLink("Player", slotID)
	if (itemLink == nil) then return 0, 0, 0, 0, 0, 0, 0 end
	PDA_HiddenTooltip:SetHyperlink(itemLink)
	
	local int = 0
	local hit = 0
	local crit = 0
	local sp = 0
	local asp = 0
	local frsp = 0
	local fisp = 0
	
	for i=1, PDA_HiddenTooltip:NumLines(), 1 do
		local tempText = _G["PDA_HiddenTooltipTextLeft"..i]:GetText()
		-- SKIP IF SET BONUS --
		if not(tempText:find("Set")) then
			if (tempText:find("damage and healing done by magical")) then
				local value, count = tempText:gsub("%D+", "")
				sp = sp + tonumber(value)
			elseif (tempText:find("damage done by Arcane spells")) then
				local value, count = tempText:gsub("%D+", "")
				asp = frsp + tonumber(value)
			elseif (tempText:find("damage done by Frost spells")) then
				local value, count = tempText:gsub("%D+", "")
				frsp = frsp + tonumber(value)
			elseif (tempText:find("damage done by Fire spells")) then
				local value, count = tempText:gsub("%D+", "")
				fisp = fisp + tonumber(value)
			elseif (tempText:find("Nature Spell Damage")) then
			elseif (tempText:find("Frost Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				frsp = frsp + tonumber(value)
			elseif (tempText:find("Arcane Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				asp = frsp + tonumber(value)
			elseif (tempText:find("Shadow Spell Damage")) then
			elseif (tempText:find("Fire Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				fisp = sp + tonumber(value)
			elseif (tempText:find("Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				sp = sp + tonumber(value)
			elseif (tempText:find("critical strike with spells")) then
				local value, count = tempText:gsub("%D+", "")
				crit = crit + tonumber(value)
			elseif (tempText:find("hit with spells")) then
				local value, count = tempText:gsub("%D+", "")
				hit = hit + tonumber(value)
			elseif (tempText:find("Intellect")) then
				local value, count = tempText:gsub("%D+", "")
				int = int + tonumber(value)
			elseif (tempText:find("All Stats")) then
				local value, count = tempText:gsub("%D+", "")
				int = int + tonumber(value)
			end
		end
	end
	
	return int, hit, crit, sp, asp, frsp, fisp
end

function PDAM_GetSetBonusData()
	local magister = 0
	local sorcerer = 0
	local arcanist = 0
	local bloodvine = 0
	local illusionist = 0
	
	for i=1, 19, 1 do
		local itemLink = GetInventoryItemLink("Player", i)
		if not(itemLink == nil) then
			PDA_HiddenTooltip:SetHyperlink(itemLink)
			local firstline = _G["PDA_HiddenTooltipTextLeft".."1"]:GetText()
			if (firstline:find("Magister")) then
				magister = magister + 1
			elseif (firstline:find("Sorcerer's")) then
				sorcerer = sorcerer + 1
			elseif (firstline:find("Arcanist")) then
				arcanist = arcanist + 1
			elseif (firstline:find("Bloodvine")) then
				bloodvine = bloodvine + 1
			elseif (firstline:find("Jewel of Kajaro") or firstline:find("Illusionist") or firstline:find("Hazza'rah's Charm of Magic")) then
				illusionist = illusionist + 1
			end
		end
	end
	
	local int = 0
	local hit = 0
	local crit = 0
	local sp = 0
	local asp = 0
	local frsp = 0
	local fisp = 0
	
	if (magister >= 4) then
		sp = sp + 23
	end
	if (sorcerer >= 6) then
		sp = sp + 23
	end
	if (arcanist >= 3) then
		sp = sp + 18
	end
	if (bloodvine >= 3) then
		crit = crit + 2
	end
	if (illusionist >= 2) then
		sp = sp + 12
	end
	
	return int, hit, crit, sp, asp, frsp, fisp
end

function PDAM_SetSlotValue(slot, int, hit, crit, sp, asp, frsp, fisp)
	slot.Int:SetValue(int)
	slot.Hit:SetValue(hit)
	slot.Crit:SetValue(crit)
	slot.SP:SetValue(sp)
	slot.ASP:SetValue(asp)
	slot.FRSP:SetValue(frsp)
	slot.FISP:SetValue(fisp)
end

function PDAM_AutoFill()
	PDAM_SetSlotValue(PDAM_Head, PDAM_GetItemData(1))
	PDAM_SetSlotValue(PDAM_Neck, PDAM_GetItemData(2))
	PDAM_SetSlotValue(PDAM_Shoulder, PDAM_GetItemData(3))
	PDAM_SetSlotValue(PDAM_Back, PDAM_GetItemData(15))
	PDAM_SetSlotValue(PDAM_Chest, PDAM_GetItemData(5))
	PDAM_SetSlotValue(PDAM_Shirt, PDAM_GetItemData(4))
	PDAM_SetSlotValue(PDAM_Tabard, PDAM_GetItemData(19))
	PDAM_SetSlotValue(PDAM_Wrist, PDAM_GetItemData(9))
	
	PDAM_SetSlotValue(PDAM_Hands, PDAM_GetItemData(10))
	PDAM_SetSlotValue(PDAM_Waist, PDAM_GetItemData(6))
	PDAM_SetSlotValue(PDAM_Legs, PDAM_GetItemData(7))
	PDAM_SetSlotValue(PDAM_Feet, PDAM_GetItemData(8))
	PDAM_SetSlotValue(PDAM_Finger1, PDAM_GetItemData(11))
	PDAM_SetSlotValue(PDAM_Finger2, PDAM_GetItemData(12))
	PDAM_SetSlotValue(PDAM_Trinket1, PDAM_GetItemData(13))
	PDAM_SetSlotValue(PDAM_Trinket2, PDAM_GetItemData(14))

	PDAM_SetSlotValue(PDAM_MainHand, PDAM_GetItemData(16))
	PDAM_SetSlotValue(PDAM_OffHand, PDAM_GetItemData(17))
	PDAM_SetSlotValue(PDAM_Wand, PDAM_GetItemData(18))
	
	PDAM_SetSlotValue(PDAM_SetBonus, PDAM_GetSetBonusData())
end

function PDAM_Clear()
	PDAM_SetSlotValue(PDAM_Head, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Neck, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Shoulder, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Back, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Chest, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Shirt, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Tabard, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Wrist, 0, 0, 0, 0, 0, 0, 0)
	
	PDAM_SetSlotValue(PDAM_Hands, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Waist, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Legs, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Feet, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Finger1, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Finger2, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Trinket1, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Trinket2, 0, 0, 0, 0, 0, 0, 0)

	PDAM_SetSlotValue(PDAM_MainHand, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_OffHand, 0, 0, 0, 0, 0, 0, 0)
	PDAM_SetSlotValue(PDAM_Wand, 0, 0, 0, 0, 0, 0, 0)
	
	PDAM_SetSlotValue(PDAM_SetBonus, 0, 0, 0, 0, 0, 0, 0)
end

function PDAM_ReturnSum(valueName)
	local sum = 0
	sum = sum + PDAM_Head[valueName]:GetValue()
	sum = sum + PDAM_Neck[valueName]:GetValue()
	sum = sum + PDAM_Shoulder[valueName]:GetValue()
	sum = sum + PDAM_Back[valueName]:GetValue()
	sum = sum + PDAM_Chest[valueName]:GetValue()
	sum = sum + PDAM_Shirt[valueName]:GetValue()
	sum = sum + PDAM_Tabard[valueName]:GetValue()
	sum = sum + PDAM_Wrist[valueName]:GetValue()

	sum = sum + PDAM_Hands[valueName]:GetValue()
	sum = sum + PDAM_Waist[valueName]:GetValue()
	sum = sum + PDAM_Legs[valueName]:GetValue()
	sum = sum + PDAM_Feet[valueName]:GetValue()
	sum = sum + PDAM_Finger1[valueName]:GetValue()
	sum = sum + PDAM_Finger2[valueName]:GetValue()
	sum = sum + PDAM_Trinket1[valueName]:GetValue()
	sum = sum + PDAM_Trinket2[valueName]:GetValue()

	sum = sum + PDAM_MainHand[valueName]:GetValue()
	sum = sum + PDAM_OffHand[valueName]:GetValue()
	sum = sum + PDAM_Wand[valueName]:GetValue()
	
	sum = sum + PDAM_SetBonus[valueName]:GetValue()
	
	return sum
end

function PDAM_CalculateAll()
	local totalInt = PDAM_ReturnSum("Int")
	local totalHit = PDAM_ReturnSum("Hit")
	local totalCrit = PDAM_ReturnSum("Crit")
	local totalSP = PDAM_ReturnSum("SP")
	local totalASP = PDAM_ReturnSum("ASP")
	local totalFRSP = PDAM_ReturnSum("FRSP")
	local totalFISP = PDAM_ReturnSum("FISP")
	
	local race = UnitRace("Player"):lower()
	if (race:find("gnome")) then totalInt = totalInt + 133
	elseif (race:find("human")) then totalInt = totalInt + 125
	elseif (race:find("troll")) then totalInt = totalInt + 121
	elseif (race:find("undead")) then totalInt = totalInt + 123 end
	
	local percentIntBonus = 0
	local percentDamageBonus = 0
	local critModifier = 0.50
	
	local spellTexture = 135349
	local spellLink = "\124cffff8000\124Hitem:19019::::::::60:::::\124h[Thunderfury, Blessed Blade of the Windseeker]\124h\124r"
	local spellDamage = 0
	local spellInterval = 0
	local spellCoefficient = 0
	
	local useASP = false
	local useFRSP = false
	local useFISP = false
	
	if (PDAM_SpellFrame.SpellName == "FrostBoltSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP = PDAM_FrostBoltSpellModify(totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP)
	elseif (PDAM_SpellFrame.SpellName == "BlizzardSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP = PDAM_BlizzardSpellModify(totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP)
	elseif (PDAM_SpellFrame.SpellName == "ArcaneMissilesSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP = PDAM_ArcaneMissilesSpellModify(totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP)
	elseif (PDAM_SpellFrame.SpellName == "ArcaneExplosionSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP = PDAM_ArcaneExplosionSpellModify(totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP)
	elseif (PDAM_SpellFrame.SpellName == "ScorchSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP = PDAM_ScorchSpellModify(totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP)
	elseif (PDAM_SpellFrame.SpellName == "FireballSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP = PDAM_FireballSpellModify(totalInt, totalHit, totalCrit, totalSP, totalASP, totalFRSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useASP, useFRSP, useFISP)
	end
	
	totalInt = totalInt + totalInt * percentIntBonus
	totalCrit = totalCrit / 100 + 0.0183 + (totalInt / 60.6 / 100)
	totalHit = totalHit / 100 + 0.83
	
	local combinedSP = totalSP;
	if (useASP) then
		combinedSP = combinedSP + totalASP
	end
	if (useFRSP) then
		combinedSP = combinedSP + totalFRSP
	end
	if (useFISP) then
		combinedSP = combinedSP + totalFISP
	end
	
	-- I SEE YOU ARE DIGGING THROUGH MY SOURCE CODE ^^, HERE HAVE THE GRAND FORMULA --
	local dps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local plusIntDps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + (totalCrit + 1 / 60.6 / 100) * critModifier) * (totalHit)
	local plusHitDps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit + 0.01)
	local plusCritDps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + (totalCrit + 0.01) * critModifier) * (totalHit)
	local plusCombinedSPDps = ((spellDamage + (combinedSP + 1) * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local intValue = (plusIntDps - dps) / dps
	local hitValue = (plusHitDps - dps) / dps
	local critValue = (plusCritDps - dps) / dps
	local combinedSPValue = (plusCombinedSPDps - dps) / dps
	
	PDAM_TotalInt.Value:SetText(totalInt)
	PDAM_TotalHit.Value:SetText(string.format("%0i", totalHit * 100) .. "%")
	PDAM_TotalCrit.Value:SetText(string.format("%0i", totalCrit * 100) .. "%")
	PDAM_TotalSP.Value:SetText(combinedSP)
	
	PDAM_IntValue.Value1:SetText(string.format("%0.2f", intValue * 100) .. "%")
	PDAM_IntValue.Value2:SetText(string.format("%0.2f", intValue / combinedSPValue))
	PDAM_HitValue.Value1:SetText(string.format("%0.2f", hitValue * 100) .. "%")
	PDAM_HitValue.Value2:SetText(string.format("%0.2f", hitValue / combinedSPValue))
	PDAM_CritValue.Value1:SetText(string.format("%0.2f", critValue * 100) .. "%")
	PDAM_CritValue.Value2:SetText(string.format("%0.2f", critValue / combinedSPValue))
	PDAM_SPValue.Value1:SetText(string.format("%0.2f", combinedSPValue * 100) .. "%")
	PDAM_SPValue.Value2:SetText(1)
	PDAM_DPSFrame.Title:SetText("DPS: " .. dps)
	
	PDAM_SpellFrame.SpellButton:SetNormalTexture(spellTexture)
	PDAM_SpellFrame.SpellButton.Link = spellLink
	PDAM_SpellFrame.Damage.Name:SetText("Damage:")
	PDAM_SpellFrame.Damage.Value:SetText(spellDamage)
	PDAM_SpellFrame.Interval.Name:SetText("Interval:")
	PDAM_SpellFrame.Interval.Value:SetText(spellInterval)
	PDAM_SpellFrame.Coefficient.Name:SetText("Coefficient:")
	PDAM_SpellFrame.Coefficient.Value:SetText(spellCoefficient)
end