
function PDAW_GetItemData(slotID)
	local itemLink = GetInventoryItemLink("Player", slotID)
	if (itemLink == nil) then return 0, 0, 0, 0, 0, 0 end
	PDA_HiddenTooltip:SetHyperlink(itemLink)
	
	local int = 0
	local hit = 0
	local crit = 0
	local sp = 0
	local ssp = 0
	local fisp = 0
	
	for i=1, PDA_HiddenTooltip:NumLines(), 1 do
		local tempText = _G["PDA_HiddenTooltipTextLeft"..i]:GetText()
		-- SKIP IF SET BONUS --
		if not(tempText:find("Set")) then
			if (tempText:find("damage and healing done by magical")) then
				local value, count = tempText:gsub("%D+", "")
				sp = sp + tonumber(value)
			elseif (tempText:find("damage done by Shadow spells")) then
				local value, count = tempText:gsub("%D+", "")
				ssp = ssp + tonumber(value)
			elseif (tempText:find("damage done by Fire spells")) then
				local value, count = tempText:gsub("%D+", "")
				fisp = fisp + tonumber(value)
			elseif (tempText:find("Nature Spell Damage")) then
			elseif (tempText:find("Frost Spell Damage")) then
			elseif (tempText:find("Arcane Spell Damage")) then
			elseif (tempText:find("Shadow Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				ssp = sp + tonumber(value)
			elseif (tempText:find("Fire Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				fisp = sp + tonumber(value)
			elseif (tempText:find("Spell Damage")) then
				local value, count = tempText:gsub("%D+", "")
				sp = sp + tonumber(value)
			elseif (tempText:find("critical strike with spells")) then
				local value, count = tempText:gsub("%D+", "")
				crit = crit + tonumber(value)
			elseif (tempText:find("hit with spells")) then
				local value, count = tempText:gsub("%D+", "")
				hit = hit + tonumber(value)
			elseif (tempText:find("Intellect")) then
				local value, count = tempText:gsub("%D+", "")
				int = int + tonumber(value)
			elseif (tempText:find("All Stats")) then
				local value, count = tempText:gsub("%D+", "")
				int = int + tonumber(value)
			end
		end
	end
	
	return int, hit, crit, sp, ssp, fisp
end

function PDAW_GetSetBonusData()
	local dreadmist = 0
	local deathmist = 0
	local nemesis = 0
	local bloodvine = 0
	local demoniac = 0
	
	for i=1, 19, 1 do
		local itemLink = GetInventoryItemLink("Player", i)
		if not(itemLink == nil) then
			PDA_HiddenTooltip:SetHyperlink(itemLink)
			local firstline = _G["PDA_HiddenTooltipTextLeft".."1"]:GetText()
			if (firstline:find("Dreadmist")) then
				dreadmist = dreadmist + 1
			elseif (firstline:find("Deathmist")) then
				deathmist = deathmist + 1
			elseif (firstline:find("Nemesis")) then
				nemesis = nemesis + 1
			elseif (firstline:find("Bloodvine")) then
				bloodvine = bloodvine + 1
			elseif (firstline:find("Kezan's Unstoppable Taint") or firstline:find("Demoniac") or firstline:find("Hazza'rah's Charm of Destruction")) then
				demoniac = demoniac + 1
			end
		end
	end
	
	local int = 0
	local hit = 0
	local crit = 0
	local sp = 0
	local ssp = 0
	local fisp = 0
	
	if (dreadmist >= 4) then
		sp = sp + 23
	end
	if (deathmist >= 6) then
		sp = sp + 23
	end
	if (nemesis >= 3) then
		sp = sp + 23
	end
	if (bloodvine >= 3) then
		crit = crit + 2
	end
	if (demoniac >= 2) then
		sp = sp + 12
	end
	
	return int, hit, crit, sp, ssp, fisp
end

function PDAW_SetSlotValue(slot, int, hit, crit, sp, ssp, fisp)
	slot.Int:SetValue(int)
	slot.Hit:SetValue(hit)
	slot.Crit:SetValue(crit)
	slot.SP:SetValue(sp)
	slot.SSP:SetValue(ssp)
	slot.FISP:SetValue(fisp)
end

function PDAW_AutoFill()
	PDAW_SetSlotValue(PDAW_Head, PDAW_GetItemData(1))
	PDAW_SetSlotValue(PDAW_Neck, PDAW_GetItemData(2))
	PDAW_SetSlotValue(PDAW_Shoulder, PDAW_GetItemData(3))
	PDAW_SetSlotValue(PDAW_Back, PDAW_GetItemData(15))
	PDAW_SetSlotValue(PDAW_Chest, PDAW_GetItemData(5))
	PDAW_SetSlotValue(PDAW_Shirt, PDAW_GetItemData(4))
	PDAW_SetSlotValue(PDAW_Tabard, PDAW_GetItemData(19))
	PDAW_SetSlotValue(PDAW_Wrist, PDAW_GetItemData(9))
	
	PDAW_SetSlotValue(PDAW_Hands, PDAW_GetItemData(10))
	PDAW_SetSlotValue(PDAW_Waist, PDAW_GetItemData(6))
	PDAW_SetSlotValue(PDAW_Legs, PDAW_GetItemData(7))
	PDAW_SetSlotValue(PDAW_Feet, PDAW_GetItemData(8))
	PDAW_SetSlotValue(PDAW_Finger1, PDAW_GetItemData(11))
	PDAW_SetSlotValue(PDAW_Finger2, PDAW_GetItemData(12))
	PDAW_SetSlotValue(PDAW_Trinket1, PDAW_GetItemData(13))
	PDAW_SetSlotValue(PDAW_Trinket2, PDAW_GetItemData(14))

	PDAW_SetSlotValue(PDAW_MainHand, PDAW_GetItemData(16))
	PDAW_SetSlotValue(PDAW_OffHand, PDAW_GetItemData(17))
	PDAW_SetSlotValue(PDAW_Wand, PDAW_GetItemData(18))
	
	PDAW_SetSlotValue(PDAW_SetBonus, PDAW_GetSetBonusData())
end

function PDAW_Clear()
	PDAW_SetSlotValue(PDAW_Head, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Neck, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Shoulder, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Back, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Chest, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Shirt, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Tabard, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Wrist, 0, 0, 0, 0, 0, 0)
	
	PDAW_SetSlotValue(PDAW_Hands, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Waist, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Legs, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Feet, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Finger1, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Finger2, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Trinket1, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Trinket2, 0, 0, 0, 0, 0, 0)

	PDAW_SetSlotValue(PDAW_MainHand, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_OffHand, 0, 0, 0, 0, 0, 0)
	PDAW_SetSlotValue(PDAW_Wand, 0, 0, 0, 0, 0, 0)
	
	PDAW_SetSlotValue(PDAW_SetBonus, 0, 0, 0, 0, 0, 0)
end

function PDAW_ReturnSum(valueName)
	local sum = 0
	sum = sum + PDAW_Head[valueName]:GetValue()
	sum = sum + PDAW_Neck[valueName]:GetValue()
	sum = sum + PDAW_Shoulder[valueName]:GetValue()
	sum = sum + PDAW_Back[valueName]:GetValue()
	sum = sum + PDAW_Chest[valueName]:GetValue()
	sum = sum + PDAW_Shirt[valueName]:GetValue()
	sum = sum + PDAW_Tabard[valueName]:GetValue()
	sum = sum + PDAW_Wrist[valueName]:GetValue()

	sum = sum + PDAW_Hands[valueName]:GetValue()
	sum = sum + PDAW_Waist[valueName]:GetValue()
	sum = sum + PDAW_Legs[valueName]:GetValue()
	sum = sum + PDAW_Feet[valueName]:GetValue()
	sum = sum + PDAW_Finger1[valueName]:GetValue()
	sum = sum + PDAW_Finger2[valueName]:GetValue()
	sum = sum + PDAW_Trinket1[valueName]:GetValue()
	sum = sum + PDAW_Trinket2[valueName]:GetValue()

	sum = sum + PDAW_MainHand[valueName]:GetValue()
	sum = sum + PDAW_OffHand[valueName]:GetValue()
	sum = sum + PDAW_Wand[valueName]:GetValue()
	
	sum = sum + PDAW_SetBonus[valueName]:GetValue()
	
	return sum
end

function PDAW_CalculateAll()
	local totalInt = PDAW_ReturnSum("Int")
	local totalHit = PDAW_ReturnSum("Hit")
	local totalCrit = PDAW_ReturnSum("Crit")
	local totalSP = PDAW_ReturnSum("SP")
	local totalSSP = PDAW_ReturnSum("SSP")
	local totalFISP = PDAW_ReturnSum("FISP")
	
	local race = UnitRace("Player"):lower()
	if (race:find("gnome")) then totalInt = totalInt + 119
	elseif (race:find("human")) then totalInt = totalInt + 110
	elseif (race:find("orc")) then totalInt = totalInt + 107
	elseif (race:find("undead")) then totalInt = totalInt + 108 end
	
	local percentIntBonus = 0
	local percentDamageBonus = 0
	local critModifier = 0.50
	
	local spellTexture = 135349
	local spellLink = "\124cffff8000\124Hitem:19019::::::::60:::::\124h[Thunderfury, Blessed Blade of the Windseeker]\124h\124r"
	local spellDamage = 0
	local spellInterval = 0
	local spellCoefficient = 0
	
	local useSSP = false
	local useFISP = false
	
	if (PDAW_SpellFrame.SpellName == "ShadowBoltSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP = PDAW_ShadowBoltSpellModify(totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP)
	elseif (PDAW_SpellFrame.SpellName == "CorruptionSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP = PDAW_CorruptionSpellModify(totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP)
	elseif (PDAW_SpellFrame.SpellName == "AgonyCurseSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP = PDAW_AgonyCurseSpellModify(totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP)
	elseif (PDAW_SpellFrame.SpellName == "SearingPainSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP = PDAW_SearingPainSpellModify(totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP)
	elseif (PDAW_SpellFrame.SpellName == "HellfireSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP = PDAW_HellfireSpellModify(totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP)
	elseif (PDAW_SpellFrame.SpellName == "FireRainSpell") then
		totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP = PDAW_FireRainSpellModify(totalInt, totalHit, totalCrit, totalSP, totalSSP, totalFISP, percentIntBonus, percentDamageBonus, critModifier, spellTexture, spellLink, spellDamage, spellInterval, spellCoefficient, useSSP, useFISP)
	end
	
	totalInt = totalInt + totalInt * percentIntBonus
	totalCrit = totalCrit / 100 + 0.0183 + (totalInt / 60.6 / 100)
	totalHit = totalHit / 100 + 0.83
	
	local combinedSP = totalSP;
	if (useSSP) then
		combinedSP = combinedSP + totalSSP
	end
	if (useFISP) then
		combinedSP = combinedSP + totalFISP
	end
	
	-- I SEE YOU ARE DIGGING THROUGH MY SOURCE CODE ^^, HERE HAVE THE GRAND FORMULA --
	local dps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local plusIntDps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + (totalCrit + 1 / 60.6 / 100) * critModifier) * (totalHit)
	local plusHitDps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit + 0.01)
	local plusCritDps = ((spellDamage + combinedSP * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + (totalCrit + 0.01) * critModifier) * (totalHit)
	local plusCombinedSPDps = ((spellDamage + (combinedSP + 1) * spellCoefficient) / spellInterval) * (1 + percentDamageBonus) * (1 + totalCrit * critModifier) * (totalHit)
	local intValue = (plusIntDps - dps) / dps
	local hitValue = (plusHitDps - dps) / dps
	local critValue = (plusCritDps - dps) / dps
	local combinedSPValue = (plusCombinedSPDps - dps) / dps
	
	PDAW_TotalInt.Value:SetText(totalInt)
	PDAW_TotalHit.Value:SetText(string.format("%0i", totalHit * 100) .. "%")
	PDAW_TotalCrit.Value:SetText(string.format("%0i", totalCrit * 100) .. "%")
	PDAW_TotalSP.Value:SetText(combinedSP)
	
	PDAW_IntValue.Value1:SetText(string.format("%0.2f", intValue * 100) .. "%")
	PDAW_IntValue.Value2:SetText(string.format("%0.2f", intValue / combinedSPValue))
	PDAW_HitValue.Value1:SetText(string.format("%0.2f", hitValue * 100) .. "%")
	PDAW_HitValue.Value2:SetText(string.format("%0.2f", hitValue / combinedSPValue))
	PDAW_CritValue.Value1:SetText(string.format("%0.2f", critValue * 100) .. "%")
	PDAW_CritValue.Value2:SetText(string.format("%0.2f", critValue / combinedSPValue))
	PDAW_SPValue.Value1:SetText(string.format("%0.2f", combinedSPValue * 100) .. "%")
	PDAW_SPValue.Value2:SetText(1)
	PDAW_DPSFrame.Title:SetText("DPS: " .. dps)
	
	PDAW_SpellFrame.SpellButton:SetNormalTexture(spellTexture)
	PDAW_SpellFrame.SpellButton.Link = spellLink
	PDAW_SpellFrame.Damage.Name:SetText("Damage:")
	PDAW_SpellFrame.Damage.Value:SetText(spellDamage)
	PDAW_SpellFrame.Interval.Name:SetText("Interval:")
	PDAW_SpellFrame.Interval.Value:SetText(spellInterval)
	PDAW_SpellFrame.Coefficient.Name:SetText("Coefficient:")
	PDAW_SpellFrame.Coefficient.Value:SetText(spellCoefficient)
end